"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.CircleLinkedList = void 0;

var _toollib = require("../common/toollib");

var _LinkedListNode = require("./LinkedListNode");

var _LinkedList2 = require("./LinkedList");

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

/**
* @description 单向循环链表
* @export CircleLinkedList
* @class CircleLinkedList
* @extends {LinkedList}
*/
var CircleLinkedList = /*#__PURE__*/function (_LinkedList) {
  _inherits(CircleLinkedList, _LinkedList);

  var _super = _createSuper(CircleLinkedList);

  function CircleLinkedList() {
    var customizedComparer = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : null;

    _classCallCheck(this, CircleLinkedList);

    return _super.call(this, customizedComparer);
  }
  /**
   * 向循环链表添加数据
   *
   * @param {*} data
   * @returns
   * @memberof CircleLinkedList
   */


  _createClass(CircleLinkedList, [{
    key: "append",
    value: function append(data) {
      // 1. 创建新元素
      var newNode = new _LinkedListNode.LinkedListNode(data); // 2.1 链表为空时，直接添加到末尾

      if (this.isEmpty) {
        this.__head = newNode;
        this.__tail = newNode;
      } // 2.2 链表非空时，末尾添加新元素
      else {
        this.__tail.next = newNode;
        this.__tail = newNode;
      } // 2.3 将新的尾节点的后继指向头节点


      this.__tail.next = this.__head; // 3. 内部计数加1

      this.__count += 1;
      return true;
    }
    /**
     * 向循环链表指定位置插入元素
     *
     * @param {number} position 插入位置
     * @param {*} data
     * @returns 插入结果：true/false
     * @memberof LinkedList
     */

  }, {
    key: "insert",
    value: function insert(position, data) {
      // 1. 边界检查（插入位置）
      if (position < 0 || position > this.__count) throw new Error('position out of range.'); // 2. 创建新元素

      var newNode = new _LinkedListNode.LinkedListNode(data); // 3.1插入到链表头部

      if (position === 0) {
        newNode.next = this.__head;
        this.__head = newNode;
        this.__tail.next = this.__head; // 内部计数加1

        this.__count += 1;
      } // 3.2插入到链表尾部
      else if (position === this.size) {
        this.append(data);
      } // 3.3以外
      else {
        var previous = null;
        var current = this.__head;
        var index = 0;

        while (index < position) {
          previous = current;
          current = current.next;
          index++;
        }

        previous.next = newNode;
        newNode.next = current; // 内部计数加1

        this.__count += 1;
      }

      return true;
    }
    /**
     * 删除链表中某个元素
     *
     * @param {*} data 元素数据
     * @returns 删除结果：true/false
     * @memberof LinkedList
     */

  }, {
    key: "remove",
    value: function remove(data) {
      var position = this.indexOf(data);
      if (position === -1) return false;
      return this.removeAt(position);
    }
    /**
     * 删除循环链表指定位置元素
     *
     * @param {number} position 位置下标
     * @returns 删除结果：true/false
     * @memberof LinkedList
     */

  }, {
    key: "removeAt",
    value: function removeAt(position) {
      // 1.边界检查
      if (position < 0 || position >= this.__count) return false; // 2.1.链表中只要一个元素的时候

      if (this.size === 1) {
        // position 只能是 0
        this.__head = this.__tail = null;
      } // 2.2.链表中有多个元素的时候
      else {
        var index = 0;
        var previous = null;
        var current = this.__head; // 2.2.1.找到指定位置元素

        while (index++ < position) {
          previous = current;
          current = current.next;
        } // 2.2.2.使当前元素不再被引用(当删除的不是头节点)


        previous && (previous.next = current.next); // A. 如果删除的是头节点

        if (position === 0) {
          // 更新 head 的指针
          this.__head = current.next; // 重新连接首尾

          this.__tail.next = this.__head;
        } // B. 如果删除的是尾节点
        else if (position === this.size - 1) {
          // 更新 tail 的指针
          this.__tail = previous;
        }
      } // 3.内部计数减1


      this.__count -= 1;
      return true;
    }
    /**
     * 根据指定元素数据获取在链表中的位置下标
     *
     * @param {*} data 元素数据
     * @returns 位置下标
     * @memberof LinkedList
     */

  }, {
    key: "indexOf",
    value: function indexOf(data) {
      var index = 0;
      var current = this.__head; // 根据指点数据查找节点元素，探查到尾节点后需停止

      while (index < this.size) {
        if (this.__comparator(current.data, data)) {
          return index;
        }

        current = current.next;
        index += 1;
      } // 没有找到符合的节点元素


      return -1;
    }
    /**
     * 遍历链表
     *
     * @param {function} callback
     * @memberof LinkedList
     */

  }, {
    key: "traverse",
    value: function traverse(callback) {
      // 参数检查（回调函数）
      if (!callback || !(0, _toollib.isFunction)(callback)) return; // 计数

      var index = 0; // 起始元素设为 head

      var current = this.__head; // 头部起始，向后遍历，到链表尾结束

      while (index < this.size) {
        callback(current.data);
        current = current.next;
        index += 1;
      }
    }
    /**
     * 迭代下一个节点
     * 即链表头节点指针后移
     *
     * @returns 所在节点数据
     * @memberof CircleLinkedList
     */

  }, {
    key: "getNext",
    value: function getNext() {
      if (this.isEmpty) return undefined;
      var current = this.__head;

      if (this.size > 1) {
        this.__head = current.next;
        this.__tail = current;
      }

      return current.data;
    }
    /**
     * 获取字符串
     *
     * @returns 循环链表的字符串
     * @memberof LinkedList
     */

  }, {
    key: "toString",
    value: function toString() {
      var str = '[ ';
      var index = 0;
      var current = this.__head;

      while (index < this.size) {
        str += current + ' -> ';
        current = current.next;
        index += 1;
      }

      str += " | Count: ".concat(this.size, " ]");
      return str;
    }
  }]);

  return CircleLinkedList;
}(_LinkedList2.LinkedList);

exports.CircleLinkedList = CircleLinkedList;