"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Queue = void 0;

var _ArrayBasedStruct2 = _interopRequireDefault(require("../ArrayBasedStruct"));

var _toollib = require("../common/toollib");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

/**
 * 队列结构
 *
 * @export Queue
 * @class Queue
 * @extends {ArrayBasedStruct}
 */
var Queue = /*#__PURE__*/function (_ArrayBasedStruct) {
  _inherits(Queue, _ArrayBasedStruct);

  var _super = _createSuper(Queue);

  function Queue() {
    _classCallCheck(this, Queue);

    return _super.call(this);
  }
  /**
   * 加入队列
   *
   * @param {*} element
   * @returns
   * @memberof Queue
   */


  _createClass(Queue, [{
    key: "enqueue",
    value: function enqueue(element) {
      return this.__items.push(element);
    }
    /**
     * 移出队列
     *
     * @returns
     * @memberof Queue
     */

  }, {
    key: "dequeue",
    value: function dequeue() {
      return this.__items.shift();
    }
    /**
     * 查看队列首
     *
     * @returns
     * @memberof Queue
     */

  }, {
    key: "front",
    value: function front() {
      if (this.isEmpty) return undefined;
      return (0, _toollib.deepCopy)(this.__items[0]);
    }
    /**
     * 遍历队列
     *
     * @memberof Queue
     */

  }, {
    key: "traverse",
    value: function traverse(callback) {
      // 检查回调函数
      if (!(0, _toollib.isFunction)(callback)) return; // 获取队列全部元素的数组的拷贝

      var items = this.getItems(this.__items);

      for (var index = 0; index < this.size; index++) {
        var element = items[index];
        callback(element, index);
      }
    }
  }]);

  return Queue;
}(_ArrayBasedStruct2["default"]);

exports.Queue = Queue;