"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.TreeNode = exports.RBTreeNode = exports.NODE_COLOR_RED = exports.NODE_COLOR_BLACK = void 0;

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

/*
 * @Author: coderdeh
 * @Date: 2022-07-11 15:58:41
 * @LastEditors: coderdeh
 * @LastEditTime: 2022-07-11 15:58:48
 * @FilePath: \coderdeh-vue\src\Tree\TreeNode.js
 * @Description: 
 */
var NODE_COLOR_RED = true;
exports.NODE_COLOR_RED = NODE_COLOR_RED;
var NODE_COLOR_BLACK = false;
/**
 * 二叉树节点类
 * 内部用
 * @class TreeNode
 */

exports.NODE_COLOR_BLACK = NODE_COLOR_BLACK;

var TreeNode = /*#__PURE__*/function () {
  function TreeNode(data) {
    _classCallCheck(this, TreeNode);

    this.data = data;
    this.left = null;
    this.right = null;
    this.parent = null;

    this.toString = function () {
      return data.toString();
    };
  }

  _createClass(TreeNode, [{
    key: "isLeftChild",
    get: function get() {
      return this.parent && this.parent.left === this;
    }
  }, {
    key: "isRightChild",
    get: function get() {
      return this.parent && this.parent.right === this;
    }
  }, {
    key: "sibling",
    get: function get() {
      return this.parent ? this.isLeftChild ? this.parent.right : this.parent.left : null;
    }
  }, {
    key: "isLeaf",
    get: function get() {
      return this.left === null && this.right === null;
    }
  }, {
    key: "nearNephew",
    get: function get() {
      return this.sibling ? this.isLeftChild ? this.sibling.left : this.sibling.right : null;
    }
  }, {
    key: "farNephew",
    get: function get() {
      return this.sibling ? this.isLeftChild ? this.sibling.right : this.sibling.left : null;
    }
  }]);

  return TreeNode;
}();
/**
 * 红黑树节点类
 *
 * @export
 * @class RBTreeNode
 * @extends {TreeNode}
 */


exports.TreeNode = TreeNode;

var RBTreeNode = /*#__PURE__*/function (_TreeNode) {
  _inherits(RBTreeNode, _TreeNode);

  var _super = _createSuper(RBTreeNode);

  function RBTreeNode(data) {
    var _this;

    var color = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : NODE_COLOR_RED;

    _classCallCheck(this, RBTreeNode);

    _this = _super.call(this, data);
    _this.__color = color;

    _this.toString = function () {
      return "(".concat(this.__color ? 'Red' : 'Black', ")").concat(this.data.toString());
    };

    return _this;
  }

  _createClass(RBTreeNode, [{
    key: "isRed",
    get: function get() {
      return this.__color;
    }
  }, {
    key: "isBlack",
    get: function get() {
      return !this.__color;
    }
    /**
     * 设节点颜色
     * 
     * @description 给节点设颜色（红/黑）
     * @param {NODE_COLOR_RED | NODE_COLOR_BLACK} color
     * @memberof RBTreeNode
     */

  }, {
    key: "color",
    value: function color(_color) {
      this.__color = _color;
    }
    /**
     * 设相反颜色
     *
     * @param {NODE_COLOR_RED | NODE_COLOR_BLACK} color
     * @memberof RBTreeNode
     */

  }, {
    key: "reverseColor",
    value: function reverseColor(color) {
      this.__color = !color;
    }
  }]);

  return RBTreeNode;
}(TreeNode);

exports.RBTreeNode = RBTreeNode;